#!/bin/bash

length=${2}
repitions=1
time=${3}

case "$1" in
	"" | --help)
	echo "Goal generator for accumulate test"
	echo "Use: ./create_goal.sh <type> <length> <time>"
	echo "Known types: spin_store, spin_stream, rdma, p4"
	
	;;
	 
        spin_stream)

echo "num_ranks 2
rank 0{
l0: put ${length}b to 1 tag 10
}"

echo "rank 1{
l0: append ${length}b to priority_list ph 2 allowed 0 ct 5 tag 10 
}" 

	    ;;
        spin_stream_pong)
packets=$(($length/4096 + 1));
if [ "$(($length % 4096))" -eq "0" ]; then packets=$(($packets-1)); fi

echo "num_ranks 2
rank 0{
l0: put ${length}b to 1 tag 10
l1: append ${length}b to priority_list allowed 1 ct 5 tag 10
l1 requires l0
l2: test 5 for ${packets}
l2 requires l1"
op=3
for(( i=1; i<$repitions; i=i+1))
do
	echo "l${op}: put ${length}b to 1 tag 10"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	echo "l${op}: test 5 for $((($i+1)*$packets))"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	
done
echo "}"

echo "rank 1{
l0: append ${length}b to priority_list ph 3 allowed 0 ct 5 tag 10 
}" 


	    ;;
        rdma)
echo "num_ranks 2
rank 0{
l0: put ${length}b to 1 tag 10
}"

echo "rank 1{
l0: append ${length}b to priority_list allowed 0 ct 5 tag 10 
l1: test 5 for 1  
l1 requires l0
l2: calc ${time}
l2 requires l1
}"



            ;;
        rdma_pong)
echo "num_ranks 2
rank 0{
l0: put ${length}b to 1 tag 10
l1: append ${length}b to priority_list allowed 1 ct 5 tag 10
l1 requires l0
l2: test 5 for 1
l2 requires l1"
op=3
for(( i=1; i < ${repitions}; i=i+1))
do
	echo "l${op}: put ${length}b to 1 tag 10"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	echo "l${op}: test 5 for $(($i+1))"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	
done
echo "}"

echo "rank 1{
l0: append ${length}b to priority_list allowed 0 ct 5 tag 10 
l1: test 5 for 1  
l1 requires l0
l2: calc ${time}
l2 requires l1
l3: put ${length}b to 0 tag 10
l3 requires l2"
op=4
for(( i=1; i<$repitions; i=i+1))
do
	echo "l${op}: test 5 for $((i+1))"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	echo "l${op}: calc  ${time}"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	echo "l${op}: put ${length}b to 0 tag 10"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
done
echo "}"



            ;;
        p4)
echo "num_ranks 2
rank 0{
l0: put ${length}b to 1 tag 10
}"

echo "rank 1{
l0: append ${length}b to priority_list allowed 0 ct 5 tag 10 
l1: test 5 for 1  
l1 requires l0
l2: calc ${time}
l2 requires l1
}"
 
            ;;

        p4_pong)
echo "num_ranks 2
rank 0{
l0: put ${length}b to 1 tag 10
l1: append ${length}b to priority_list allowed 1 ct 5 tag 10
l1 requires l0
l2: test 5 for 1
l2 requires l1"
op=3
for(( i=1; i<$repitions; i=i+1))
do
	echo "l${op}: put ${length}b to 1 tag 10"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	echo "l${op}: test 5 for $(($i+1))"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	
done
echo "}"

echo "rank 1{
l0: append ${length}b to priority_list allowed 0 ct 5 tag 10 
l1: test 5 for 1  
l1 requires l0
l2: calc  ${time}
l2 requires l1
l3: put ${length}b to 0 tag 10
l3 requires l2"

op=4
for(( i=1; i<$repitions; i=i+1))
do
	echo "l${op}: test 5 for $((i+1))"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	echo "l${op}: calc  ${time}"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
	echo "l${op}: put ${length}b to 0 tag 10"
	echo "l${op} requires l$((op-1))"
	op=$((op+1))
done
echo "}"
            ;;
esac






