#!/bin/bash


start=4096
finish=$((4*1024*1024))
step=2

nodes=2
hpus=8

#Generate network with 1 switch and two nodes
../create_simple_network.sh $nodes


declare -a configurations=("onchip" "discrete")
declare -a simulator=("spin")
declare -a goal=("spin_stream")

for(( j=0; j<${#configurations[@]}; j=j+1))
do
echo "Configuration: ${configurations[j]}"
echo -n "size"
for(( hpu=1; hpu<=hpus; hpu=hpu+1)); do
	echo -n " ${hpu}_hpus"
done
echo ""
for (( c=start; c<=finish; c=c*step))
do  
    echo -n "$c"
    for(( i=0; i<${#simulator[@]}; i=i+1))
    do
	./create_goal.sh ${goal[i]} $c $time > accumulate.goal
  	for(( hpu=1; hpu<=hpus; hpu=hpu+1))
    	do
	../run_simulation.sh ${simulator[i]} accumulate params_${configurations[j]} $nodes $hpu  > temp_res 2>&1
    	extime=$(grep 'Maximum finishing time' temp_res | awk '{print $4}')
       	echo -n " $extime" 
	done
    done
    echo ""
done
   echo ""
   echo ""
done

rm config.ini
rm temp_res
rm *.goal
rm *.bin
rm *.dot


