#!/bin/bash


start=8
finish=8192
step=8184

nodes=2
hpus=4


#Generate network with 1 switch and two nodes
../create_simple_network.sh $nodes

declare -a simulator=("rdma" "p4" "spin")
declare -a goal=("rdma" "p4" "spin_stream")

echo "Visualization for Accumulate:"
 
for (( c=start; c<=finish; c=c+step))
do  
    time=$(../mainCPU/mainCPU 2 ${c})
    for(( i=0; i<${#simulator[@]}; i=i+1))
    do
	./create_goal.sh ${goal[i]} $c $time > accumulate_${goal[$i]}_${c}_onchip.goal
 	echo "Type: ${goal[$i]}; Size: ${c}; Parameters: onchip"
	../run_debug.sh ${simulator[i]} accumulate_${goal[$i]}_${c}_onchip params_onchip $nodes $hpus > temp_res 2>&1
	echo "Type: ${goal[$i]}; Size: ${c}; Parameters: discrete"
	./create_goal.sh ${goal[i]} $c $time > accumulate_${goal[$i]}_${c}_discrete.goal
	../run_debug.sh ${simulator[i]} accumulate_${goal[$i]}_${c}_discrete params_discrete $nodes $hpus > temp_res 2>&1

    done
    echo ""
done

rm config.ini
rm temp_res
rm *.goal
rm *.bin
rm *.dot


