#!/bin/bash

hosts=${2}
length=${3}

case "$1" in
	"" | --help)
	echo "Goal generator for Broadcast test"
	echo "Use: ./create_goal.sh <type> <hosts> <length>"
	echo "Known types: spin_store, spin_stream, rdma, p4"
	
	;;
        spin_store)
	

	for((power=2; $power < $hosts; )); do power=$(($power*2)); done
	if [ $power -ne $hosts ]; then power=$(($power/2)); fi

	echo "num_ranks $(($hosts))"

	handler="ph 0"
	if [ "$length" -gt "4096" ]; then
		handler="ch 1"
	fi

        i=0
	op=0
	echo "rank 0{"
	for ((half = $(($power/2)); half>=1; half=half/2 )); do
	    if [ "$(($i % ($half*2)))" -eq "0" ] && [ "$i" -lt "$power" ]; then
	      	 echo "l${op}: put ${length}b to $(($i+$half)) tag 20"
		 op=$(($op+1))
		 if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	    	fi
	    fi
	done
	if [ "$i" -lt "$(($hosts-$power))" ]; then
	      echo "l${op}: put ${length}b to $(($i+$power)) tag 20"
	      if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	      fi
	fi
	echo "}"

		for (( i=1; i<hosts;i++))
		do
		if [ $(($i % 2)) -eq "0" ]; then
		echo "rank ${i}{
l0: append ${length}b to priority_list ${handler} arg1 ${i} arg2 ${hosts} arg3 20 arg4 ${length} mem 16 allowed -1 ct 0 tag 20
}"
else
		echo "rank ${i}{
l0: append ${length}b to priority_list allowed -1 ct 0 tag 20
}"
		fi
		done		
            ;;
         
        spin_stream)
	

	for((power=2; $power < $hosts; )); do power=$(($power*2)); done
	if [ $power -ne $hosts ]; then power=$(($power/2)); fi

	echo "num_ranks $(($hosts))"
	i=0
	op=0
	echo "rank 0{"
	for ((half = $(($power/2)); half>=1; half=half/2 )); do
	    if [ "$(($i % ($half*2)))" -eq "0" ] && [ "$i" -lt "$power" ]; then
	      	 echo "l${op}: put ${length}b to $(($i+$half)) tag 20"
		 op=$(($op+1))
		 if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	    	fi
	    fi
	done
	if [ "$i" -lt "$(($hosts-$power))" ]; then
	      echo "l${op}: put ${length}b to $(($i+$power)) tag 20"
	      if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	      fi
	fi
	echo "}"

		for (( i=1; i<hosts;i++))
		do
		if [ $(($i % 2)) -eq "0" ]; then
		echo "rank ${i}{
l0: append ${length}b to priority_list ph 0 arg1 ${i} arg2 ${hosts} arg3 20 mem 16 allowed -1 ct 0 tag 20
}"
else
		echo "rank ${i}{
l0: append ${length}b to priority_list allowed -1 ct 0 tag 20
}"
		fi
		done		
            ;;
        

        rdma)

	for((power=2; $power < $hosts; )); do power=$(($power*2)); done
	if [ $power -ne $hosts ]; then power=$(($power/2)); fi

	echo "num_ranks $(($hosts))"

        i=0
	op=0
	echo "rank 0{"
	for ((half = $(($power/2)); half>=1; half=half/2 )); do
	    if [ "$(($i % ($half*2)))" -eq "0" ] && [ "$i" -lt "$power" ]; then
	      	 echo "l${op}: put ${length}b to $(($i+$half)) tag 20"
		 op=$(($op+1))
		 if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	    	fi
	    fi
	done
	     

	if [ "$i" -lt "$(($hosts-$power))" ]; then
	      echo "l${op}: put ${length}b to $(($i+$power)) tag 20"
	      if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	      fi
	fi
	echo "}"
	for (( i=1; i<hosts;i++)); do
		echo "rank ${i}{
l0: append ${length}b to priority_list allowed -1 ct 0 use_once tag 20
l1: test 0 for 1
l1 requires l0"
		op=2
	  	for ((half = $(($power/2)); half>=1; half=half/2 )); do
	    	 if [ "$(($i % ($half*2)))" -eq "0" ] && [ "$i" -lt "$power" ]; then
	      	  echo "l${op}: put ${length}b to $(($i+$half)) tag 20"
		  op=$(($op+1))
		   if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	    	   fi
		 fi
		done
	     

		if [ "$i" -lt "$(($hosts-$power))" ]; then
		   echo "l${op}: put ${length}b to $(($i+$power)) tag 20"
		   if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	    	   fi
		fi
		echo "}"
	done



            ;;
        p4)

	for((power=2; $power < $hosts; )); do power=$(($power*2)); done
	if [ $power -ne $hosts ]; then power=$(($power/2)); fi

	echo "num_ranks $(($hosts))"

	i=0
	op=0
	echo "rank 0{"
	for ((half = $(($power/2)); half>=1; half=half/2 )); do
	    if [ "$(($i % ($half*2)))" -eq "0" ] && [ "$i" -lt "$power" ]; then
	      	 echo "l${op}: put ${length}b to $(($i+$half)) tag 20"
		 op=$(($op+1))
		 if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	    	fi
	    fi
	done
	     

	if [ "$i" -lt "$(($hosts-$power))" ]; then
	      echo "l${op}: put ${length}b to $(($i+$power)) tag 20"
	      if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	      fi
	fi
	echo "}"
	for (( i=1; i<hosts;i++)); do
		echo "rank ${i}{
l0: append ${length}b to priority_list allowed -1 ct 0 use_once tag 20"
		op=1
	  	for ((half = $(($power/2)); half>=1; half=half/2 )); do
	    	 if [ "$(($i % ($half*2)))" -eq "0" ] && [ "$i" -lt "$power" ]; then
	      	  echo "l${op}: tput ${length}b to $(($i+$half)) when 0 reaches 1 ct ${op} tag 20"
		  op=$(($op+1))
		   if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	    	   fi
		 fi
		done
	     

		if [ "$i" -lt "$(($hosts-$power))" ]; then
		   echo "l${op}: tput ${length}b to $(($i+$power)) when 0 reaches 1 ct ${op}  tag 20"
		   if [ "$op" -ge "2" ]; then
		    echo "l$(($op-1)) requires l$(($op-2))"
	    	   fi
		fi
		echo "}"
	done
            ;;
esac






