#!/bin/bash


nodes_start=2
nodes_fin=1024

hpus=4

start=4
finish=$((4*1024*1024))

step=2



declare -a configurations=("onchip" "discrete")
declare -a goal=("rdma" "p4" "spin_store" "spin_stream")
declare -a simulator=("rdma" "p4" "spin" "spin" )


for(( j=0; j<${#configurations[@]}; j=j+1))
do
echo "Configuration: ${configurations[j]}"
echo "p size ${goal[*]}"
for (( p=nodes_start; p<=nodes_fin; p=p*step))
do 
for (( c=start; c<=finish; c=c*step))
do  
    echo -n "$p $c" 
    for(( i=0; i<${#goal[@]}; i=i+1))
    do
	    ./create_goal.sh ${goal[i]} ${p} ${c} > bcast.goal
	    ../run_simulation.sh ${simulator[i]} bcast params_${configurations[j]} $p $hpus > temp_res 2>&1
	    extime=$(grep 'Maximum finishing time' temp_res | awk '{print $4}')
	    echo -n " $extime"
    done

    echo ""
done
done
   echo ""
   echo ""
done


rm temp_res
rm *.bin
rm config.ini
rm *.goal




