#!/bin/bash


start=8
finish=8192
step=8184

nodes=16
hpus=4
repitions=1
 
declare -a simulator=("rdma" "p4" "spin" "spin")
declare -a goal=("rdma" "p4" "spin_store" "spin_stream")


echo "Visualization for Broadcast ${nodes} nodes:"
 
for (( c=start; c<=finish; c=c+step))
do  

    for(( i=0; i<${#simulator[@]}; i=i+1))
    do
	./create_goal.sh ${goal[i]} $nodes $c > bcast_${goal[$i]}_${nodes}_${c}b_onchip.goal
 	echo "Type: ${goal[$i]}; Size: ${c}; Parameters: onchip"
	../run_debug.sh ${simulator[i]} bcast_${goal[$i]}_${nodes}_${c}b_onchip params_onchip $nodes $hpus > temp_res 2>&1
 	echo "Type: ${goal[$i]}; Size: ${c}; Parameters: discrete"
	./create_goal.sh ${goal[i]} $nodes $c > bcast_${goal[$i]}_${nodes}_${c}b_discrete.goal
	../run_debug.sh ${simulator[i]} bcast_${goal[$i]}_${nodes}_${c}b_discrete params_discrete $nodes $hpus > temp_res 2>&1
 
 
    done
    echo ""
 

done

rm config.ini
rm temp_res
rm *.goal
rm *.bin



