#!/bin/bash

declare -a required_bins=("sim_p4" "sim_spin")

for(( i=0; i<${#required_bins[@]}; i=i+1))
do
	if [ ! -f "${required_bins[i]}" ]
	then
		echo "Please, execute ./init.sh {PATH TO GEM5}"
		exit 1
	fi
done

declare -a known_tests=("pingpong" "datatypes" "storage" "accumulate" "bcast")
echo "#Create visualisations: ${known_tests[*]}" 

current=${PWD}

for(( i=0; i<${#known_tests[@]}; i=i+1))
do
	echo "#Exectuing ${known_tests[i]} benchmark"
	cd ${known_tests[i]} && ./run_create_vis.sh 
	cd $current  
done


echo "#Done. You could find figureas in ../DrawViz/  folder" 
