#!/bin/bash

length=${2}
vlen=${3}
stride=${4}
offset=${5}
time=${6}

case "$1" in
       	"" | --help)
	echo "Goal generator for datatypes test"
	echo "Use: ./create_goal.sh <type> <length> <vlen> <stride> <offset> <time>"
	echo "Known types: spin_stream, rdma, p4"
	
	  ;;
        spin_stream)
packets=$(($length/4096 + 1));
if [ "$(($length % 4096))" -eq "0" ]; then packets=$(($packets-1)); fi


echo "num_ranks 2
rank 0{
l0: put ${length}b to 1 tag 10
}"

echo "rank 1{
l0: append ${length}b to priority_list ph 8 arg1 ${vlen} arg2 ${stride} arg3 ${offset} mem 16 allowed 0 ct 5 tag 10 
l1: test 5 for ${packets}
l1 requires l0
}" 


	

	    ;;
        rdma)
echo "num_ranks 2
rank 0{
l0: put ${length}b to 1 tag 10
}"

echo "rank 1{
l0: append ${length}b to priority_list allowed 0 ct 5 tag 10 
l1: test 5 for 1  
l1 requires l0
l2: calc ${time}
l2 requires l1
}"



            ;;
        p4)
echo "num_ranks 2
rank 0{
l0: put ${length}b to 1 tag 10
}"

echo "rank 1{
l0: append ${length}b to priority_list allowed 0 ct 5 tag 10 
l1: test 5 for 1  
l1 requires l0
l2: calc ${time}
l2 requires l1
}"

            ;;
esac






