#!/bin/bash


start=16
finish=$((4*1024*1024))
c=$((4*1024*1024))

step=2

nodes=2
hpus=4


#Generate network with 1 switch and two nodes
../create_simple_network.sh $nodes

declare -a configurations=("onchip" "discrete")
declare -a simulator=("rdma" "p4" "spin")
declare -a goal=("rdma" "p4" "spin_stream")
offset=0


for(( j=0; j<${#configurations[@]}; j=j+1))
do
echo "Configuration: ${configurations[j]}"
echo "size block ${goal[*]}"
for (( vlen=start; vlen<=finish; vlen=vlen*step))
do  
    stride=$(($vlen*2))
    time=$(../mainCPU/mainCPU 3 ${c} ${vlen} ${stride})
    echo -n "$c $vlen"
    for(( i=0; i<${#simulator[@]}; i=i+1))
    do
	./create_goal.sh ${goal[i]} $c $vlen $stride $offset $time  > datatypes.goal
	../run_simulation.sh ${simulator[i]} datatypes params_${configurations[j]} $nodes $hpus  > temp_res 2>&1
    	extime=$(grep 'Maximum finishing time' temp_res | awk '{print $4}')
       	echo -n " $extime" 
    done
    echo ""

done
  echo ""
  echo ""
done

rm config.ini
rm temp_res
rm *.goal
rm *.bin
rm *.dot


