#!/bin/bash


start=16
finish=8192
step=8176


c=262144


nodes=2
hpus=4
 
#Generate network with 1 switch and two nodes
../create_simple_network.sh $nodes

 
declare -a simulator=("rdma" "p4" "spin")
declare -a goal=("rdma" "p4" "spin_stream")
offset=0

echo "Visualization for Datatypes. Message length: ${c}."

for (( vlen=start; vlen<=finish; vlen=vlen+step))
do  
    stride=$(($vlen*2))
    time=$(../mainCPU/mainCPU 3 ${c} ${vlen} ${stride})
    for(( i=0; i<${#simulator[@]}; i=i+1))
    do
	./create_goal.sh ${goal[i]} $c $vlen $stride $offset $time  > datatypes_${goal[$i]}_${c}_${vlen}b_onchip.goal
	echo "Type: ${goal[$i]}; Block size: ${vlen}; Stride: ${stride}; Parameters: onchip"
	../run_debug.sh ${simulator[i]} datatypes_${goal[$i]}_${c}_${vlen}b_onchip params_onchip $nodes $hpus > temp_res 2>&1
 	echo "Type: ${goal[$i]}; Block size: ${vlen}; Stride: ${stride}; Parameters: discrete"
	./create_goal.sh ${goal[i]} $c $vlen $stride $offset $time  > datatypes_${goal[$i]}_${c}_${vlen}b_discrete.goal
	../run_debug.sh ${simulator[i]} datatypes_${goal[$i]}_${c}_${vlen}b_discrete params_discrete $nodes $hpus > temp_res 2>&1
 
 
    done
    echo ""
 

done

rm config.ini
rm temp_res
rm *.goal
rm *.bin
rm *.dot



