#!/bin/bash


start=4
finish=$((4*1024*1024))
step=2

nodes=2
hpus=4


#Generate network with 1 switch and two nodes
../create_simple_network.sh $nodes

declare -a configurations=("onchip" "discrete")
declare -a simulator=("rdma" "p4" "spin"  "spin")
declare -a goal=("rdma" "p4" "spin_store" "spin_stream")

for(( j=0; j<${#configurations[@]}; j=j+1))
do
echo "Configuration: ${configurations[j]}"
echo "size ${goal[*]}"
for (( c=start; c<=finish; c=c*step))
do  
    echo -n "$c"
    for(( i=0; i<${#goal[@]}; i=i+1))
    do
	./create_goal.sh ${goal[i]} $c > pingpong.goal
	../run_simulation.sh ${simulator[i]} pingpong params_${configurations[j]} $nodes $hpus  > temp_res 2>&1
    	extime=$(grep 'Maximum finishing time' temp_res | awk '{print $4}')
       	echo -n " $extime" 
    done
    echo ""
done
echo ""
echo ""
done

rm config.ini
rm temp_res
rm *.goal
rm *.bin
rm *.dot


