#!/bin/bash


start=8
finish=8192
step=8184

nodes=2
hpus=4


#Generate network with 1 switch and two nodes
../create_simple_network.sh $nodes


declare -a simulator=("rdma" "p4" "spin" "spin")
declare -a goal=("rdma" "p4" "spin_store" "spin_stream")


echo "Visualization for PingPong test."
 
for (( c=start; c<=finish; c=c+step))
do  

    for(( i=0; i<${#simulator[@]}; i=i+1))
    do
	./create_goal.sh ${goal[i]} $c > pingpong_${goal[$i]}_${c}b_onchip.goal
	echo "Type: ${goal[$i]}; Size: ${c}; Parameters: onchip"
	../run_debug.sh ${simulator[i]}  pingpong_${goal[$i]}_${c}b_onchip params_onchip $nodes $hpus > temp_res 2>&1
	./create_goal.sh ${goal[i]} $c > pingpong_${goal[$i]}_${c}b_discrete.goal
	echo "Type: ${goal[$i]}; Size: ${c}; Parameters: discrete"
	../run_debug.sh ${simulator[i]} pingpong_${goal[$i]}_${c}b_discrete params_discrete $nodes $hpus > temp_res 2>&1
    done
    echo ""

done

rm config.ini
rm temp_res
rm *.goal
rm *.bin
rm *.dot


