#!/bin/bash

declare -a required_bins=("sim_p4" "sim_spin")

for(( i=0; i<${#required_bins[@]}; i=i+1))
do
	if [ ! -f "${required_bins[i]}" ]
	then
		echo "Please, execute ./init.sh {PATH TO GEM5}"
		exit 1
	fi
done

declare -a known_tests=("pingpong" "datatypes" "storage" "accumulate" "accumulate_hpus" "bcast" "traceRS")
echo "#Run tests: ${known_tests[*]}" 

current=${PWD}

for(( i=0; i<${#known_tests[@]}; i=i+1))
do
	echo "#Executing ${known_tests[i]} benchmark"
	if [ "${known_tests[i]}" == "accumulate_hpus" ]; then 
		cd accumulate && ./run_benchmark_hpus.sh 
		cd $current  

	else
		cd ${known_tests[i]} && ./run_benchmark.sh 
		cd $current  
	fi
	echo ""
	echo ""
done



