#!/bin/bash
#Script is used for producing verbose output and pdf figures

# $1 - sim binary
# $2 - goal file
# $3 - params
# $4 - number of hosts
# $5 - hpus per node

#parse goal file
../../txt2bin/txt2bin -i $2.goal -o $2.bin

#Parameters for simulator
PARAMETERS=$(cat ../$3)
#PARAMETERS=$(cat params_discrete)

case "$1" in
        spin)
	CPU="../../gem5_files/m5out/cpu.a15.template"
	#CPU="../../gem5_files/m5out/cpu.template2"
	#create config.ini
	../../gem5_files/ninstances.sh ../../gem5_files/m5out/root.ini ../../gem5_files/m5out/system.a15.template $CPU $4 $5 > ./config.ini
	#run simulation
	../sim_spin -f $2.bin --network-file=simplenet.dot --gem5-conf-file=config.ini $PARAMETERS -v -V $2.vis
      ;;
        rdma)
	../sim_p4 -f $2.bin --network-file=simplenet.dot $PARAMETERS -v -V $2.vis
      ;;
        p4)
	../sim_p4 -f $2.bin --network-file=simplenet.dot $PARAMETERS -v -V $2.vis

      ;;
esac


#Create pdf
mv $2.vis ../../DrawViz/$2.vis
cd ../../DrawViz
./drawviz -i $2.vis -o $2.ps
ps2pdf -sPAPERSIZE=a3 $2.ps $2.pdf
pdfcrop $2.pdf $2.pdf
rm $2.ps $2.vis
 


