#!/bin/bash

k=${2}
length=${3}
time1=${4}
time2=${5}




case "$1" in
	"" | --help)
	echo "Goal generator for accumulate test"
	echo "Use: ./create_goal.sh <type> <k> <length> <time1> <time2>"
	echo "Known types: spin_stream_write, rdma_write, p4_write, spin_stream_read, rdma_read, p4_read"
	echo "k - the number of data servers "
	echo "length - size of the update"
	echo "time1 - time is taken by mainCPU of data server to process length bytes"
	echo "time2 - time is taken by mainCPU of parity server to process length bytes"
	;;
        spin_stream_write)
packets=$(($length/4096 + 1));
if [ "$(($length % 4096))" -eq "0" ]; then packets=$(($packets-1)); fi

COUNT=0
echo "num_ranks $(($k+2))
rank $COUNT{
l0: append ${length}b to priority_list allowed -1 ct 6 tag 40"

for (( i=0; i<k;i++))
do
	echo "l$(($i+2)): put ${length}b to $(($i+2)) tag 20"
done


echo "}"


op=0
echo "rank $(($COUNT+1)){"
for (( i=0; i<k;i++))
do  
	echo "l${op}: append ${length}b to priority_list hh 13 ph 14 ch 15 mem 8 arg1 0 arg2 ${packets} allowed $(($i+2)) ct $(($i+2)) tag 53"
done


echo "}"

COUNT=$(($COUNT+1))



for (( i=0; i<k;i++))
do
COUNT=$(($COUNT+1))
echo "rank $COUNT{
l1: append ${length}b to priority_list hh 9 ph 10 mem 8 allowed -1 ct 6 tag 20
l2: append ${length}b to priority_list hh 12 allowed -1 ct 7 tag 30
}" 
done

	;;

   spin_stream_read)
COUNT=0
echo "num_ranks $(($k+2))
rank $COUNT{
l1: append ${length}b to priority_list allowed -1 ct 7 tag 50"
for (( i=0; i<k;i++))
do
	echo "l$(($i+2)): put 1b arg1 ${length} to $(($i+2)) tag 10"
done

echo "}"



echo "rank $(($COUNT+1)){"
echo "}"

COUNT=$(($COUNT+1))



for (( i=0; i<k;i++))
do
COUNT=$(($COUNT+1))
echo "rank $COUNT{
l0: append ${length}b to priority_list hh 11 allowed -1 ct 5 tag 10
}" 
done

	;;


       rdma_write)
COUNT=0
echo "num_ranks $(($k+2))
rank $COUNT{
l0: append ${length}b to priority_list allowed -1 ct 6 tag 40"

for (( i=0; i<k;i++))
do
	echo "l$(($i+2)): put ${length}b to $(($i+2)) tag 20"
done

echo "}"


op=0
echo "rank $(($COUNT+1)){"
for (( i=0; i<k;i++))
do  
	echo "l${op}: append ${length}b to priority_list allowed $(($i+2)) ct $(($i+2)) tag 53"
	op=$(($op+1))
	echo "l${op}: test $(($i+2)) for 1"
	op=$(($op+1))
	echo "l${op}: calc ${time2}"
	echo "l${op} requires l$(($op-1))"
	op=$(($op+1))
	echo "l${op}: put 1b to $(($i+2)) tag 30"
	echo "l${op} requires l$(($op-1))"
	op=$(($op+1))
done
echo "}"

COUNT=$(($COUNT+1))


for (( i=0; i<k;i++))
do
	COUNT=$(($COUNT+1))
	echo "rank $COUNT{"
	echo "l1: append ${length}b to priority_list allowed -1 ct 6 tag 20"
	echo "l2: append ${length}b to priority_list allowed -1 ct 7 tag 30"
	echo "l3: test 6 for 1"
	echo "l4: calc ${time1}"
	echo "l4 requires l3"
	echo "l5: put ${length}b to 1 tag 53"
	echo "l5 requires l4"
	echo "l6: test 7 for 1"
	echo "l7: put 1b to 0 tag 40"
	echo "l7 requires l6"
	echo "}"
done

  	;;
        p4_write)
COUNT=0
echo "num_ranks $(($k+2))
rank $COUNT{
l0: append ${length}b to priority_list allowed -1 ct 6 tag 40"

for (( i=0; i<k;i++))
do
	echo "l$(($i+2)): put ${length}b to $(($i+2)) tag 20"
done

echo "}"


op=0
echo "rank $(($COUNT+1)){"
for (( i=0; i<k;i++))
do  
  
	echo "l${op}: append ${length}b to priority_list allowed $(($i+2)) ct $(($i+2)) tag 53"
	op=$(($op+1))
	echo "l${op}: test $(($i+2)) for 1"
	op=$(($op+1))
	echo "l${op}: calc ${time2}"
	echo "l${op} requires l$(($op-1))"
	op=$(($op+1))
	echo "l${op}: put 1b to $(($i+2)) tag 30"
	echo "l${op} requires l$(($op-1))"
	op=$(($op+1))
done
echo "}"


	COUNT=$(($COUNT+1))
for (( i=0; i<k;i++))
do
	COUNT=$(($COUNT+1))
	echo "rank $COUNT{"
	echo "l1: append ${length}b to priority_list allowed -1 ct 6 tag 20"
	echo "l2: append ${length}b to priority_list allowed -1 ct 7 tag 30"
	echo "l3: test 6 for 1"
	echo "l4: calc ${time1}"
	echo "l4 requires l3"
	echo "l5: put ${length}b to 1 tag 53"
	echo "l5 requires l4"
	echo "l6: tput 1b to 0 when 7 reaches 1"
	echo "l6 requires l5"
	echo "}"
done
          ;;

        p4_read | rdma_read)
COUNT=0
echo "num_ranks $(($k+2))
rank $COUNT{
l1: append ${length}b to priority_list allowed -1 ct 7 tag 50"
for (( i=0; i<k;i++))
do
	echo "l$(($i+2)): put 1b arg1 ${length} to $(($i+2)) tag 10"
done

echo "}"



echo "rank $(($COUNT+1)){"
echo "}"

COUNT=$(($COUNT+1))




for (( i=0; i<k;i++))
do
	COUNT=$(($COUNT+1))
	echo "rank $COUNT{"
	echo "l0: append ${length}b to priority_list allowed -1 ct 5 tag 10"
	echo "l1: test 5 for 1"
	echo "l2: put ${length}b to 0 tag 50"
	echo "l2 requires l1"
	echo "}"
done
          ;;


esac




