#!/bin/bash

hpus=4

k_start=1
k_f=5

../create_simple_network.sh $(($k_f + 2))

start=4
finish=$((4*1024*1024))

step=2

declare -a configurations=("onchip" "discrete")
declare -a goal=("rdma_write" "p4_write"  "spin_stream_write" "rdma_read" "p4_read" "spin_stream_read" )
declare -a simulator=("rdma" "p4"  "spin" "rdma" "p4"  "spin")


for(( j=0; j<${#configurations[@]}; j=j+1))
do
echo "Configuration: ${configurations[j]}"
echo "size k ${goal[*]}"

for (( s=start; s<=finish; s=s*step))
do  
	time1=$(../mainCPU/mainCPU 0 ${s})
	time2=$(../mainCPU/mainCPU 1 ${s})
	for (( k=k_start; k<=k_f;k++))
	do
	
		echo -n "$s $k"
		for(( i=0; i<${#goal[@]}; i=i+1));    do
			./create_goal.sh ${goal[i]} ${k} ${s} $time1 $time2 > rs.goal
			 
			../run_simulation.sh ${simulator[i]} rs params_${configurations[j]} $(($k + 2))  $hpus > temp_res 2>&1
			extime=$(grep 'Maximum finishing time' temp_res | awk '{print $4}')
			echo -n " $extime"
		done
		echo ""
	done
done
echo ""
echo ""
done


rm temp_res
rm *.bin
rm config.ini
rm *.goal
rm *.dot
