#!/bin/bash

hpus=4

k_start=4
k_f=4

../create_simple_network.sh $(($k_f + 2))

start=8
finish=8192

step=8184

declare -a goal=("rdma_write" "p4_write"  "spin_stream_write"  "rdma_read" "p4_read" "spin_stream_read"  )
declare -a simulator=("rdma" "p4"  "spin" "rdma" "p4"  "spin")

echo "Visualization for Distributed RAID storage."

for (( s=start; s<=finish; s=s+step))
do  
	time1=$(../mainCPU/mainCPU 0 ${s})
	time2=$(../mainCPU/mainCPU 1 ${s})
	for (( k=k_start; k<=k_f;k++))
	do
 
		for(( i=0; i<${#goal[@]}; i=i+1));    do
			
 
			./create_goal.sh ${goal[i]} ${k} ${s} ${time1} ${time2} > rs_${goal[i]}_${k}_${s}_onchip.goal
			 echo "Type: ${goal[$i]}; Storage servers: ${k}; Data size: ${s}; Parameters: onchip" 
			../run_debug.sh ${simulator[i]} rs_${goal[i]}_${k}_${s}_onchip params_onchip $(($k + 2))  $hpus > temp_res 2>&1
 			./create_goal.sh ${goal[i]} ${k} ${s} ${time1} ${time2} > rs_${goal[i]}_${k}_${s}_discrete.goal
			echo "Type: ${goal[$i]}; Storage servers: ${k}; Data size: ${s}; Parameters: discrete" 
			../run_debug.sh ${simulator[i]} rs_${goal[i]}_${k}_${s}_discrete params_discrete $(($k + 2))  $hpus > temp_res 2>&1
		done
		echo ""
	done
done



rm temp_res
rm *.bin
rm config.ini
rm *.goal
rm *.dot
