#!/usr/bin/python
import sys
# coding: utf-8

# In[110]:


import subprocess
data_server = ("../mainCPU/mainCPU", "0", "512")
parity_server = ("../mainCPU/mainCPU", "1", "512")


cached_server = {}
cached_parity = {}

#trace = '/home/ktaranov/Downloads/Financial2.spc'
trace = sys.argv[1]

#APU,offset,size,op
spin = open('spin_{0}.goal'.format(trace), 'w')
rdma = open('rdma_{0}.goal'.format(trace), 'w')
p4 = open('p4_{0}.goal'.format(trace), 'w')


allops = {}
allops_parity = {}
m=1
for i in range(0,m):
    allops_parity[i] = []
max_k=0

rank0 = []
with open(trace) as f:
    for line in f:
        elements = line.split(',')
        if (max_k < int(elements[0])+1):
            max_k=int(elements[0])+1
        if int(elements[0]) in allops:   
             allops[int(elements[0])].append( [int(elements[1]), int(elements[2]), elements[3] ])
        else:
             allops[int(elements[0])]=[ [int(elements[1]), int(elements[2]), elements[3] ] ]
        rank0.append([int(elements[0]), int(elements[1]), int(elements[2]), elements[3] ])
        if elements[3].lower()=='w':
            for i in range(0,m):
                allops_parity[i].append([int(elements[0]), int(elements[1]), int(elements[2])])
        
spin.write('num_ranks {0}\nrank 0{1}\n'.format(m+max_k+1,"{"))        
p4.write('num_ranks {0}\nrank 0{1}\n'.format(m+max_k+1,"{")) 
rdma.write('num_ranks {0}\nrank 0{1}\n'.format(m+max_k+1,"{")) 

spin.write('l0: append 4048b to priority_list allowed -1 ct 6 tag 40\n'.format("{"))        
p4.write('l0: append 4048b to priority_list allowed -1 ct 6 tag 40\n'.format("{"))        
rdma.write('l0: append 4048b to priority_list allowed -1 ct 6 tag 40\n'.format("{"))    

spin.write('l1: append 4048b to priority_list allowed -1 ct 7 tag 50\n'.format("{"))        
p4.write('l1: append 4048b to priority_list allowed -1 ct 7 tag 50\n'.format("{"))        
rdma.write('l1: append 4048b to priority_list allowed -1 ct 7 tag 50\n'.format("{"))   

    
counter=2
for com in rank0:
    #print com
    if com[3].lower() == 'r':
        spin.write('l{0}: put 1b arg1 {1} to {2} tag 10\n'.format(counter,com[2],com[0]+1+m))
        p4.write('l{0}: put 1b arg1 {1} to {2} tag 10\n'.format(counter,com[2],com[0]+1+m))
        rdma.write('l{0}: put 1b arg1 {1} to {2} tag 10\n'.format(counter,com[2],com[0]+1+m))
    else:
        spin.write('l{0}: put {1}b to {2} tag 20\n'.format(counter,com[2],com[0]+1+m))
        p4.write('l{0}: put {1}b to {2} tag 20\n'.format(counter,com[2],com[0]+1+m))
        rdma.write('l{0}: put {1}b to {2} tag 20\n'.format(counter,com[2],com[0]+1+m))
    counter=counter+1
        
spin.write('{0}\n'.format("}"))        
p4.write('{0}\n'.format("}"))        
rdma.write('{0}\n'.format("}"))  
  
#print 'rank 0 is done'

for i in range(0,m):
    spin.write('rank {0}{1}\n'.format(i+1,"{")) 
    p4.write('rank {0}{1}\n'.format(i+1,"{"))        
    rdma.write('rank {0}{1}\n'.format(i+1,"{"))   
    for j in range(0,max_k): 
        spin.write('l{0}: append 4048b to priority_list hh 13 ph 14 ch 15 mem 8 allowed {1} ct {1} tag 53\n'.format(j,j+2))        
        p4.write('l{0}: append 4048b to priority_list allowed {1} ct {1} tag 53\n'.format(j,j+2))   
        rdma.write('l{0}: append 4048b to priority_list allowed {1} ct {1} tag 53\n'.format(j,j+2))      
     
    counter=[1]*max_k
    counterop=max_k
    for entry in allops_parity[i]:
  
        if not (entry[2] in cached_parity): 
            temparray = list(parity_server)
            temparray[2]=str(entry[2])
            parity_server = tuple(temparray)
            popen = subprocess.Popen(parity_server, stdout=subprocess.PIPE)
            popen.wait()
            output = popen.stdout.read()
            cached_parity[entry[2]]=int(output)
    
        ds_id = entry[0]+m+1;
        
        rdma.write('l{0}: test {1} for {2}\n'.format(counterop,ds_id,counter[ds_id-2])) 
        p4.write('l{0}: test {1} for {2}\n'.format(counterop,ds_id,counter[ds_id-2])) 
        counterop=counterop+1
        rdma.write('l{0}: calc {1}\n'.format(counterop, cached_parity[entry[2]])) 
        rdma.write('l{0} requires l{1}\n'.format(counterop,counterop-1)) 
        p4.write('l{0}: calc {1}\n'.format(counterop, cached_parity[entry[2]])) 
        p4.write('l{0} requires l{1}\n'.format(counterop,counterop-1)) 
        counterop=counterop+1
        rdma.write('l{0}: put 1b to {1} tag 30\n'.format(counterop,ds_id)) 
        rdma.write('l{0} requires l{1}\n'.format(counterop,counterop-1)) 
        p4.write('l{0}: put 1b to {1} tag 30\n'.format(counterop,ds_id)) 
        p4.write('l{0} requires l{1}\n'.format(counterop,counterop-1)) 
        counterop=counterop+1
        counter[ds_id-2]=counter[ds_id-2]+1
        
   
            
    spin.write('{0}\n'.format("}"))        
    p4.write('{0}\n'.format("}"))        
    rdma.write('{0}\n'.format("}"))   


#print 'Parity is done'


for j in range(0,max_k):
    #print 'execute data server {0} out of {1} \n'.format(j,max_k)
 
    spin.write('rank {0}{1}\nl0: append 4048b to priority_list hh 11 allowed -1 ct 5 tag 10\n'.format(m+1+j,"{"))        
    p4.write('rank {0}{1}\nl0: append 4048b to priority_list allowed -1 ct 5 tag 10\n'.format(m+1+j,"{"))        
    rdma.write('rank {0}{1}\nl0: append 4048b to priority_list allowed -1 ct 5 tag 10\n'.format(m+1+j,"{"))  
    
    spin.write('l1: append 4048b to priority_list hh 9 ph 10 mem 8 allowed -1 ct 6 tag 20\n'.format("{"))        
    p4.write('l1: append 4048b to priority_list allowed -1 ct 6 tag 20\n'.format("{"))        
    rdma.write('l1: append 4048b to priority_list allowed -1 ct 6 tag 20\n'.format("{"))    
    
    spin.write('l2: append 4048b to priority_list hh 12 allowed -1 ct 7 tag 30\n'.format("{"))        
    p4.write('l2: append 4048b to priority_list allowed -1 ct 7 tag 30\n'.format("{"))        
    rdma.write('l2: append 4048b to priority_list allowed -1 ct 7 tag 30\n'.format("{"))    
    counter_tag10=1
    counter_tag20=1
    counterop_p4=3
    counterop_rdma=3
    if j in allops:   
        for entry in allops[j]:
            if entry[2].lower()=='r':
                p4.write('l{0}: test 5 for {1}\n'.format(counterop_p4,counter_tag10)) 
                counterop_p4=counterop_p4+1
                p4.write('l{0}: put {1}b to 0 tag 50\n'.format(counterop_p4,entry[1])) 
                p4.write('l{0} requires l{1}\n'.format(counterop_p4,counterop_p4-1)) 
                counterop_p4=counterop_p4+1
                
                
                rdma.write('l{0}: test 5 for {1}\n'.format(counterop_rdma,counter_tag10)) 
                counterop_rdma=counterop_rdma+1
                rdma.write('l{0}: put {1}b to 0 tag 50\n'.format(counterop_rdma,entry[1])) 
                rdma.write('l{0} requires l{1}\n'.format(counterop_rdma,counterop_rdma-1)) 
                counterop_rdma=counterop_rdma+1
                counter_tag10=counter_tag10+1
   
            else: # for writes
                if not (entry[1] in cached_server): 
                    temparray = list(data_server)
                    temparray[2]=str(entry[1])
                    data_server = tuple(temparray)
                    popen = subprocess.Popen(data_server, stdout=subprocess.PIPE)
                    popen.wait()
                    output = popen.stdout.read()
                    cached_server[entry[1]]=int(output)
                    
                p4.write('l{0}: test 6 for {1}\n'.format(counterop_p4,counter_tag20)) 
                counterop_p4=counterop_p4+1
                p4.write('l{0}: calc {1}\n'.format(counterop_p4,cached_server[entry[1]])) 
                p4.write('l{0} requires l{1}\n'.format(counterop_p4,counterop_p4-1)) 
                counterop_p4=counterop_p4+1
                temp_p4=counterop_p4-1
                
                rdma.write('l{0}: test 6 for {1}\n'.format(counterop_rdma,counter_tag20)) 
                counterop_rdma=counterop_rdma+1
                rdma.write('l{0}: calc {1}\n'.format(counterop_rdma,cached_server[entry[1]])) 
                rdma.write('l{0} requires l{1}\n'.format(counterop_rdma,counterop_rdma-1)) 
                counterop_rdma=counterop_rdma+1
                temp_rdma=counterop_rdma-1
                
                for i in range(0,m):
                    p4.write('l{0}: put {1}b to {2} tag 53\n'.format(counterop_p4,entry[1],i+1)) 
                    p4.write('l{0} requires l{1}\n'.format(counterop_p4,temp_p4)) 
                    counterop_p4=counterop_p4+1
                    p4.write('l{0}: tput 1b to 0 when 7 reaches {1} tag 40\n'.format(counterop_p4,counter_tag20)) 
                    p4.write('l{0} requires l{1}\n'.format(counterop_p4,counterop_p4-1)) 
                    counterop_p4=counterop_p4+1 
                    
                    rdma.write('l{0}: put {1}b to {2} tag 53\n'.format(counterop_rdma,entry[1],i+1)) 
                    rdma.write('l{0} requires l{1}\n'.format(counterop_rdma,temp_rdma)) 
                    counterop_rdma=counterop_rdma+1
                    rdma.write('l{0}: test 7 for {1}\n'.format(counterop_rdma,counter_tag20)) 
                    counterop_rdma=counterop_rdma+1 
                    rdma.write('l{0}: put 1b to 0 tag 40\n'.format(counterop_rdma,counter_tag20))
                    rdma.write('l{0} requires l{1}\n'.format(counterop_rdma,counterop_rdma-1)) 
                    counterop_rdma=counterop_rdma+1 
                    
                counter_tag20=counter_tag20+1
                
                 
                
    spin.write('{0}\n'.format("}"))        
    p4.write('{0}\n'.format("}"))        
    rdma.write('{0}\n'.format("}"))   

        

spin.close()
rdma.close()
p4.close()

print max_k


