#!/bin/bash

hpus=4

declare -a configurations=("onchip" "discrete")
declare -a trace=("test" "Financial1_10000.spc" "Financial2_10000.spc" "WebSearch1_10000.spc" "WebSearch2_10000.spc" "WebSearch3_10000.spc")
declare -a goal=("rdma" "p4" "spin" )
declare -a simulator=("rdma" "p4" "spin")


for(( j=0; j<${#configurations[@]}; j=j+1))
do
	echo "Configuration: ${configurations[j]}"
	echo "trace ${goal[*]}"
	for(( tr=0; tr<${#trace[@]}; tr=tr+1));    do

		echo -n "${trace[tr]}"

		k=$(./create_goal.py ${trace[tr]})
		../create_simple_network.sh $(($k+2))

		for(( i=0; i<${#goal[@]}; i=i+1));    do
			../run_simulation.sh ${simulator[i]} "${goal[i]}_${trace[tr]}" params_${configurations[j]} $(($k+2)) $hpus > temp_res 2>&1
			extime=$(grep 'Maximum finishing time' temp_res | awk '{print $4}')
			echo -n " $extime"
		done

		echo ""
	done
	echo ""
	echo ""
done

rm temp_res
rm *.bin
rm config.ini
rm *.goal
rm *.dot
